(  TFORTH SCR EDITOR 2.0 SCR#01)
CR .( COMPILING EDITOR...)
                              

: EDITOR ;

   23 CONSTANT LAST-LINE        
   31 CONSTANT LAST-COLUMN      
   24 CONSTANT NUMBER-OF-LINES  
   32 CONSTANT NUMBER-OF-COLUMNS
    0 CONSTANT FIRST-LINE       
    0 CONSTANT FIRST-COLUMN     
  128 CONSTANT CURSOR-SYMBOL    
   21 CONSTANT NUMBER-SCREENS   
  768 CONSTANT CHARS/SCREEN     
32768 CONSTANT INIBUF           
    0 VARIABLE POINTER          
    0 VARIABLE START-OF-TEXT    
    0 VARIABLE LINE             
    0 VARIABLE COLUMN




( TFORTH SCR EDITOR 2.0  SCR#02)

: AT  SWAP 33 * + 16530 +
      17339 ! ;
: FUNCTION DUP 12 = ;
: ENTER? DUP 13 = ;
: RIGHTARROW DUP 3 = ;
: LEFTARROW DUP 2 = ;
: DOWNARROW DUP 4 = ;
: UPARROW DUP 1 = ;
: INSDEL DUP 8 = ;
: OUT? DUP 27 = ;
: START-LINE POINTER @
  NUMBER-OF-COLUMNS /
  NUMBER-OF-COLUMNS * ;
: CHARACTER  START-OF-TEXT @
  POINTER @ + C@ ;
: PUT-CURSOR  LINE @ COLUMN @
  AT  ;
: SHOW-CURSOR PUT-CURSOR
  CURSOR-SYMBOL EMIT ;
: SHOW-CHAR PUT-CURSOR CHARACTER
  EMIT ;

( TFORTH SCR EDITOR 2.0  SCR#03)

: ADVANCE COLUMN @ LAST-COLUMN <
  IF 1 COLUMN +!   1 POINTER +! 
  THEN ;
: FORWARD ADVANCE DROP ;
: STORE START-OF-TEXT @ POINTER 
  @ + C! SHOW-CHAR ADVANCE ;
: BACKWARD DROP                 
  COLUMN @ FIRST-COLUMN >       
  IF -1 COLUMN +! -1 POINTER +! 
  THEN ;                        
: NEXT-LINE DROP                
  LINE @ LAST-LINE <            
  IF 1 LINE +! NUMBER-OF-COLUMNS
     POINTER +!                 
  THEN ;                        
: BACK-LINE FIRST-COLUMN        
  COLUMN ! START-LINE POINTER ! 
  NEXT-LINE ;                   




( TFORTH SCR EDITOR 2.0  SCR#04)

: PREVIOUS-LINE 
  DROP LINE @ FIRST-LINE >           
  IF -1 LINE +! POINTER @ 
     NUMBER-OF-COLUMNS - 
     POINTER !
  THEN ;
: SHOW-LINE LINE @ 0 AT         
  START-LINE START-OF-TEXT @ +  
  NUMBER-OF-COLUMNS 0           
  DO   DUP C@ EMIT 1+
  LOOP DROP ;
: SHOW-TEXT 0 0 AT              
  START-OF-TEXT @ CHARS/SCREEN 0
  DO   DUP C@ EMIT 1+
  LOOP DROP ;
: FINDADDR   ( n -- addr )
  DUP 1 < IF QUESTION THEN
  DUP NUMBER-SCREENS >
  IF QUESTION THEN              
  CHARS/SCREEN SWAP 1- *
  INIBUF + ;

( TFORTH SCR EDITOR 2.0  SCR#05)

: INSERT DROP BL
  NUMBER-OF-COLUMNS COLUMN @ -
  1 - DUP POINTER @             
  START-OF-TEXT  @ + + SWAP     
  ?DUP IF 0 DO DUP 1 - C@ OVER  
               C! 1-
            LOOP
       THEN   C! SHOW-LINE 0 ;  
: DELETE DROP BL
  POINTER @ START-OF-TEXT @ +   
  NUMBER-OF-COLUMNS COLUMN @ -  
  1- ?DUP                       
  IF 0 DO DUP DUP 1+ C@
          SWAP C! 1+
       LOOP            
  THEN C! SHOW-LINE 0 ;
: LINE-ADDR
  NUMBER-OF-COLUMNS *
  START-OF-TEXT @ + ;
: -CMOVE
  LINE-ADDR NUMBER-OF-COLUMNS
  CMOVE ;
( TFORTH SCR EDITOR 2.0  SCR#06)

: ERASE-LINE
  BL SWAP
  LINE-ADDR  NUMBER-OF-COLUMNS
  0 DO 2DUP C! 1+
    LOOP DROP SHOW-LINE  ;
: HOLD-LINE
  LINE @ LINE-ADDR PAD
  NUMBER-OF-COLUMNS CMOVE ;
: DELETE-LINE   
  DROP HOLD-LINE LAST-LINE LINE 
  @ 2DUP =
  IF 2DROP
  ELSE DO I 1+ LINE-ADDR 
          I -CMOVE
       LOOP
  THEN
  LAST-LINE ERASE-LINE
  SHOW-TEXT 0 ;
: REPLACE-LINE
  PAD LINE @ -CMOVE
  SHOW-LINE ;

( TFORTH SCR EDITOR 2.0  SCR#07)

: SPREAD-LINE
  LINE @ DUP LAST-LINE
  2DUP =
  IF 2DROP ELSE
    DO I 1- LINE-ADDR I -CMOVE
    -1 +LOOP
  THEN
  ERASE-LINE SHOW-TEXT 0 ;
: INSERT-LINE
  SPREAD-LINE DROP REPLACE-LINE 
;
: PREVIOUS-BLK
  START-OF-TEXT DUP @ DUP INIBUF
  = IF 2DROP EXIT THEN 768 -
  SWAP ! SHOW-TEXT ;
: NEXT-BLK
  START-OF-TEXT DUP @ DUP 
  NUMBER-SCREENS FINDADDR =
  IF 2DROP EXIT THEN
  768 + SWAP ! SHOW-TEXT ;


( TFORTH SCR EDITOR 2.0  SCR#08)




: INS-DEL   DROP
  BEGIN  KEY RIGHTARROW
    IF INSERT
    ELSE LEFTARROW
      IF DELETE
      ELSE UPARROW
        IF DELETE-LINE
        ELSE DOWNARROW
          IF DROP SPREAD-LINE
          ELSE DROP 1
          THEN
        THEN
      THEN 
    THEN
  UNTIL ;




( TFORTH SCR EDITOR 2.0  SCR#09)

: ED-FUNCT   DROP
  KEY DUP ASCII E =
  IF DROP LINE @ ERASE-LINE
  ELSE DUP ASCII H =
    IF DROP HOLD-LINE
    ELSE DUP ASCII R =
      IF DROP REPLACE-LINE
      ELSE DUP ASCII I =
        IF DROP INSERT-LINE
        ELSE DUP ASCII N =
          IF DROP NEXT-BLK
          ELSE DUP ASCII P =
            IF DROP PREVIOUS-BLK
            ELSE DROP
            THEN
          THEN
        THEN
      THEN
    THEN
  THEN ;

         
( TFORTH SCR EDITOR 2.0  SCR#10)

: EDITIONS SHOW-CHAR ENTER?
  IF BACK-LINE                  
  ELSE DOWNARROW                
    IF NEXT-LINE              
    ELSE UPARROW              
      IF PREVIOUS-LINE        
      ELSE RIGHTARROW
        IF FORWARD            
        ELSE LEFTARROW        
          IF BACKWARD         
          ELSE INSDEL         
            IF INS-DEL     
            ELSE FUNCTION
              IF ED-FUNCT
              ELSE STORE THEN     
  THEN THEN THEN THEN THEN THEN
;
: CLR   BL OVER C! DUP
  1+ CHARS/SCREEN 1- CMOVE ;
: START 0 LINE !  0 COLUMN !
  0 POINTER ! SHOW-TEXT ;

( TFORTH SCR EDITOR 2.0  SCR#11)

: ED  START
  BEGIN
    SHOW-CURSOR KEY OUT?
    IF DROP 1
    ELSE EDITIONS 0 THEN
  UNTIL  CLS ;                  
: EDIT   ( n -- )
  FINDADDR START-OF-TEXT ! ED ;
: CLEAR   ( n -- )
  FINDADDR CLR ;
: FORTH   ( n -- )
  FINDADDR LOAD ;

( BLOCK OPERATIONS )

: COPY   ( n1 n2 -- )
  FINDADDR SWAP FINDADDR SWAP
  CHARS/SCREEN CMOVE ;
: BLKINS   ( n1 n2 -- )
  OVER SWAP 
  DO I DUP 1+ COPY -1
  +LOOP CLEAR ;
( TFORTH SCR EDITOR 2.0  SCR#12)

: BLKDEL   ( n1 n2 -- )
  DUP ROT
  DO I 1+ I COPY
  LOOP CLEAR ;
: BLKSCLR   ( n1 n2 -- )
  1+ SWAP
  DO I CLEAR LOOP ;
                                
                                
                                
                                
CR CR
.( TFORTH SCREEN EDITOR 2.0) CR 
.( PROF. ANTONIO COSTA - 1985)  
CR .( KELLY A. MURTA - 2020)    
CR CR

                                
;S                              
                                
                                
  TODDY FORTH 1.5  -  2020/MAY