\ A implementation of the midpoint circle algorithm
\ (also known as Bresenham's circle algorithm). 
\ source from http://rosettacode.org

: TASK ;

\ Create value
: VALUE ( x "<spaces>name" -- )
   CONSTANT
;

: TO  ( x "<spaces>name" -- )
   '              ( get the name of the value )
   3 +            ( increment to point at the value )
   STATE @        ( compiling? )
   IF
      COMPILE LIT ( compile LIT )
      ,           ( compile the address of the value )
      COMPILE !   ( compile ! )
   ELSE           ( immediate mode )
      !           ( update it straightaway )
   THEN
; IMMEDIATE

\ ACE PLOT routine
\ Plots pixel (x, y) with plot mode n.
\ n = 0       unplot
\     1       plot
\     2       move
\     3       change

HEX
\ CODE SETGR   \ moves graphics chars from ROM to UDG memory
\  D5 C,              \ push de        ; save IP
\  21 C, 1E08 ,       \ ld hl,$1e08
\  11 C, 3008 ,       \ ld de,$3008
\  01 C, 38 ,         \ ld bc,$0038
\  ED C, B0 C,        \ ldir
\  D1 C,              \ pop de         ; restore IP
\  NEXT               \ jp NEXT
\
\ SETGR

CODE PLOT  ( x y n -- )
  C5 C,              \ push bc
  D9 C,              \ exx
  C1 C,              \ pop bc         ; n
  D1 C,              \ pop de         ; y
  FD C, 73 C, 36 C,  \ ld (iy+$36),e  ; YCOORD
  3E C, 2F C,        \ ld a,$2F       ; 47-y
  93 C,              \ sub e          ;
  1F C,              \ rra            ; (47-y)/2
  CB C, 11 C,        \ rl c           ; n*2+cy
  D1 C,              \ pop de         ; x
  FD C, 73 C, 37 C,  \ ld (iy+$37),e  ; XCOORD
  CB C, 3B C,        \ srl e          ; x/2
  CB C, 11 C,        \ rl c           ; (n*2)*2
  47 C,              \ ld b,a
  7B C,              \ ld a,e
  04 C,              \ inc b          ; range 1 to 24
  21 C, 4071 ,       \ ld hl,$4071    ; Dfile-33
  11 C, 21 ,         \ ld de,$21      ; (y/2)*33
  19 C,              \ add hl,de      ; 
  10 C, FD C,        \ djnz -3        ; 
  5F C,              \ ld e,a         ; (y/2)*33+x/2
  19 C,              \ add hl,de      ; 
  7E C,              \ ld a,(hl)
  07 C,              \ rlca
  FE C, 10 C,        \ cp $10
  7E C,              \ ld a,(hl)
  38 C, 01 C,        \ jr c,+1
  AF C,              \ xor a
  5F C,              \ ld e,a
  16 C, 87 C,        \ ld d,$87
  79 C,              \ ld a,c
  2F C,              \ cpl
  E6 C, 03 C,        \ and $03
  47 C,              \ ld b,a
  28 C, 07 C,        \ jr z,+7
  2F C,              \ cpl
  C6 C, 02 C,        \ add a,$02
  CE C, 03 C,        \ adc a,$03
  57 C,              \ ld d,a
  43 C,              \ ld b,e
  79 C,              \ ld a,c
  0F C,              \ rrca
  0F C,              \ rrca
  0F C,              \ rrca
  9F C,              \ sbc a,a
  CB C, 59 C,        \ bit 3,c
  20 C, 04 C,        \ jr nz,+4
  AB C,              \ xor e
  07 C,              \ rlca
  9F C,              \ sbc a,a
  A8 C,              \ xor b
  A2 C,              \ and d
  AB C,              \ xor e
  77 C,              \ ld (hl),a
  D9 C,              \ exx
  C1 C,              \ pop bc
  NEXT               \ jp NEXT
DECIMAL

: VALUE 0 VALUE ;

VALUE X  VALUE Y  VALUE R  VALUE COLOR
VALUE F  VALUE DDX  VALUE DDY  VALUE DX  VALUE DY 

: CIRCLE ( x y r color -- )
  TO COLOR  TO R  TO Y  TO X
  1 R -  0 R 2* NEGATE  0 R  ( f ddx ddy dx dy )
  TO DY  TO DX  TO DDY  TO DDX  TO F
  X     Y R + COLOR PLOT
  X     Y R - COLOR PLOT
  X R + Y COLOR     PLOT
  X R - Y COLOR     PLOT
  BEGIN DX DY < WHILE
    F 0< 0= IF
      DY  1-      TO DY
      DDY 2 + DUP TO DDY
      F +         TO F
    THEN
    DX 1+       TO DX
    DDX 2 + DUP TO DDX
    F 1+ +      TO F
    X DX + Y DY + COLOR PLOT
    X DX - Y DY + COLOR PLOT
    X DX + Y DY - COLOR PLOT
    X DX - Y DY - COLOR PLOT
    X DY + Y DX + COLOR PLOT
    X DY - Y DX + COLOR PLOT
    X DY + Y DX - COLOR PLOT
    X DY - Y DX - COLOR PLOT
  REPEAT ;
