\ ----------------------------------------------------
\ Port to ZX81 Toddy Forth of the routines presented
\ at "Micro Sistemas" brazilian magazine issue Nr 49, 
\ from Ivan Camilo da Cruz's trs80 article, Sound in
\ Forth.
\ ----------------------------------------------------

.( THIS PROGRAM PRODUCES VARIED) CR
.( SOUND EFFECTS THROUGH TAPE  ) CR
.( OUTPUT. WHEN READY, ADJUST  ) CR
.( THE TV VOLUME AND TYPE      ) CR
.( "ZORRA".                    ) CR CR

: TASK ;

HEX

\ The word ROTSOM and derived will be executed in
\ FAST mode ( see the word ZORRA).

CODE ROTSOM  ( dur2 dur1 -- )
  E1 C,           \ POP HL      ; load HL with 2OS
  D3 C, FF C,     \ OUT (FF),A  ; VSYNC off
  41 C,           \ LD B,C      ; first half duration
  10 C, FE C,     \ DJNZ -2
  DB C, FE C,     \ IN A,(FE)   ; VSYNC on
  45 C,           \ LD B,L      ; second half duration
  10 C, FE C,     \ DJNZ -2
  C1 C,           \ POP BC      ; new TOS
  NEXT            \ jp NEXT


: BEEP-AGUDO  ( dur -- )
  1
  DO
    1 DUP ROTSOM
  LOOP
;

: BEEP-MEDIO  ( dur -- )
  1
  DO
    20 DUP ROTSOM
  LOOP
;
: BEEP-GRAVE  ( dur -- )
  1
  DO
    FF DUP ROTSOM
  LOOP
;
: BEEP-VARIAVEL  ( freq dur -- )
  0
  DO
    DUP DUP ROTSOM
  LOOP
  DROP
;
: RAIO<  ( freq< freq> -- )
  SWAP
  DO I 1 BEEP-VARIAVEL
  LOOP
;
: RAIO>  ( freq> freq< -- )
  2DUP + ROT ROT
  DO
    DUP I - 1 BEEP-VARIAVEL
  LOOP
  DROP
;
: SIRENE  ( freq> freq< repeat -- )
  0
  DO
    2DUP RAIO>
    2DUP SWAP RAIO<
  LOOP
  2DROP
; DECIMAL
: ZORRA
  FAST
  200 50 2 SIRENE
  0 255 10 220 55 190 RAIO< RAIO< RAIO<
  190 55 220 1 255 0 RAIO> RAIO> RAIO>
  230 25 3 SIRENE
  180 70 70 180 180 70 70 180 RAIO< RAIO> RAIO< RAIO>
  200 0 170 0 140 0 110 0 RAIO> RAIO> RAIO> RAIO>
  80 0 50 0 20 0 RAIO> RAIO> RAIO>
  0 220 0 190 0 160 0 130 RAIO< RAIO< RAIO< RAIO<
  0 100 0 70 0 40 0 10 RAIO< RAIO< RAIO< RAIO<
  650 0 3 SIRENE
  SLOW
;

.( COMPILATION DONE) CR CR